# Copyright (c) 2011 Volvox Development Team
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
# Author: Konstantin Lepa <konstantin.lepa@gmail.com>

from ctemplate cimport CTemplate
from error_type cimport ErrorType
from string cimport string, const_char_ptr
from libcpp.vector cimport vector
from libc.stdint cimport uint32_t

cdef extern from  "pyctpp2/cengine.h" namespace "pyctpp2":
    cdef cppclass CEngine:
        CEngine()
        bint Init(uint32_t, uint32_t, uint32_t, uint32_t)
        bint set_include_dirs(vector[string] &)
        bint LoadBytecode(const_char_ptr, CTemplate **)
        bint Parse(const_char_ptr, CTemplate **)
        bint ParseText(const_char_ptr, CTemplate **)
        bint AddUserFunction(const_char_ptr, const_char_ptr)
        string last_error_message()
        ErrorType last_error_type()

